 
/*********************************************************************************
 *  Copyright© 2010 Gabriele Valentini (gabriele.valentini@mail.polimi.it),	 *
 *                  Luigi Malagò (malago@elet.polimi.it)                         *
 *										 *
 *  This file is part of Evoptool.						 *
 * 										 *
 *  Evptool is free software: you can redistribute it and/or modify              *
 *  it under the terms of the GNU General Public License as published by         *
 *  the Free Software Foundation, either version 3 of the License, or            *
 *  (at your option) any later version.                                          *
 *										 *
 *  Evoptool is distributed in the hope that it will be useful,                  *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of  		 *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 		 *
 *  GNU General Public License for more details.				 *
 *										 *
 *  You should have received a copy of the GNU General Public License		 *
 *  along with Evoptool.  If not, see <http://www.gnu.org/licenses/>. 		 *	
 *********************************************************************************/

#ifndef COMPARATOR_H_
#define COMPARATOR_H_

#include <iostream> 
#include <stdio.h>
#include <vector>

#include <Algorithm.h>
#include <ObjectiveFunction.h>
#include <PermutationInstance.h>
#include <BinaryInstance.h>

/* This class defines comparator functors for several object types. */

class Comparator {
	Algorithm* _algo;
public:
	Comparator(Algorithm* algo);
	virtual ~Comparator();

	bool operator ()(BinaryInstance *a, BinaryInstance *b);
	bool operator ()(Algorithm *a, Algorithm *b);
	bool operator ()(PermutationInstance *a, PermutationInstance *b);
};
#endif
