
/*********************************************************************************
 *  Copyright© 2010 Gabriele Valentini (gabriele.valentini@mail.polimi.it)	 *
 *										 *
 *  This file is part of Evoptool.						 *
 * 										 *
 *  Evptool is free software: you can redistribute it and/or modify              *
 *  it under the terms of the GNU General Public License as published by         *
 *  the Free Software Foundation, either version 3 of the License, or            *
 *  (at your option) any later version.                                          *
 *										 *
 *  Evoptool is distributed in the hope that it will be useful,                  *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of  		 *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 		 *
 *  GNU General Public License for more details.				 *
 *										 *
 *  You should have received a copy of the GNU General Public License		 *
 *  along with Evoptool.  If not, see <http://www.gnu.org/licenses/>.    	 *	
 *********************************************************************************/

#ifndef GRAPHICSTOOL_H
#define GRAPHICSTOOL_H

#include <cv.h>
#include <highgui.h>

#include "BinaryInstance.h"

using namespace std;

/* This static class defines a set of operators to manage the transformation between BinaryInstance and 
 * monochromatic image. */

class GraphicsTool {
public:
        static BinaryInstance* imageToBinaryInstance(char *filename);
	static bool binaryInstanceToImage(char *instance, unsigned int length, char *destinationFile);
	static bool binaryInstanceToImage(BinaryInstance *instance, char *destinationFile);
};

#endif
