
/*********************************************************************************
 *  Copyright© 2010 Gabriele Valentini (gabriele.valentini@mail.polimi.it)	 *
 *										 *
 *  This file is part of Evoptool.						 *
 * 										 *
 *  Evptool is free software: you can redistribute it and/or modify              *
 *  it under the terms of the GNU General Public License as published by         *
 *  the Free Software Foundation, either version 3 of the License, or            *
 *  (at your option) any later version.                                          *
 *										 *
 *  Evoptool is distributed in the hope that it will be useful,                  *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of  		 *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 		 *
 *  GNU General Public License for more details.				 *
 *										 *
 *  You should have received a copy of the GNU General Public License		 *
 *  along with Evoptool.  If not, see <http://www.gnu.org/licenses/>.    	 *	
 *********************************************************************************/

#ifndef SVD_H
#define SVD_H

#include <math.h>

using namespace std;

/* This static class implements a set of functions usuful to deal with Singular Value Decomposition.
 * The SVD algorithm implemented is a C++ version of the Numerical Recipies SVD. */

class SVD {

public:
        
        /* Singular Value Decomposition */
        static void svd(double **a, double *w, double **v, int rows, int cols);
        static double* svbksb(double **u, double *w, double **v, int rows, int cols, double *b);
        static int zeroNegligables(double *m, int length, double threshold);
        
        /* Utils */
	static double pythag(double a, double b);
	static double sign(double a, double b);
	static double abs(double a);
};

#endif
