
/*********************************************************************************
 *  Copyright© 2010 Gabriele Valentini (gabriele.valentini@mail.polimi.it)	 *
 *										 *
 *  This file is part of Evoptool.						 *
 * 										 *
 *  Evptool is free software: you can redistribute it and/or modify              *
 *  it under the terms of the GNU General Public License as published by         *
 *  the Free Software Foundation, either version 3 of the License, or            *
 *  (at your option) any later version.                                          *
 *										 *
 *  Evoptool is distributed in the hope that it will be useful,                  *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of  		 *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 		 *
 *  GNU General Public License for more details.				 *
 *										 *
 *  You should have received a copy of the GNU General Public License		 *
 *  along with Evoptool.  If not, see <http://www.gnu.org/licenses/>.    	 *	
 *********************************************************************************/

#ifndef SOLVER_H
#define SOLVER_H

#include <iostream>
#include <gtkmm.h>

#include "Algorithm.h"

using namespace std;

/* This class defines the Solver object. This object is a wrapper around an algorithm object, which takes care
 * about the execution of a test and the collection of statistics data. */

class Solver {
	Algorithm **_algorithms;		/* Array of pointers to algorithm objects.			*/
	unsigned int _averageOver;		/* Number of objects in the array.				*/
	string _fileName;			/* File name of simple statistics.				*/
public:
        Solver(Algorithm **algorithms, unsigned int averageOver, string fileName);
        virtual ~Solver();	
	
	void solve(Glib::Mutex *mutex = NULL, bool *condition = NULL, unsigned int generations = 1);
	string getAlgorithmName();
private:
	bool runCondition(Glib::Mutex *mutex, bool *condition);
};
#endif
