 
/*********************************************************************************
 *  Copyright© 2010 Luigi Malagò (malago@elet.polimi.it)                         *
 *										 *
 *  This file is part of Evoptool.						 *
 * 										 *
 *  Evptool is free software: you can redistribute it and/or modify              *
 *  it under the terms of the GNU General Public License as published by         *
 *  the Free Software Foundation, either version 3 of the License, or            *
 *  (at your option) any later version.                                          *
 *										 *
 *  Evoptool is distributed in the hope that it will be useful,                  *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of  		 *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 		 *
 *  GNU General Public License for more details.				 *
 *										 *
 *  You should have received a copy of the GNU General Public License		 *
 *  along with Evoptool.  If not, see <http://www.gnu.org/licenses/>. 		 *	
 *********************************************************************************/

#ifndef RANDOM_SEED_H
#define RANDOM_SEED_H

#include <sys/time.h>

/* Returns a random seed usuful to initialize a random number generator. */
unsigned long int random_seed() {
	unsigned int seed, rd;
	struct timeval tv;
	FILE *devrandom;
	bool verbose = false;
	
	if ((devrandom = fopen("/dev/random","r")) == NULL) {
		gettimeofday(&tv,0);
		seed = tv.tv_sec + tv.tv_usec;
		if (verbose) printf("Got seed %u from gettimeofday()\n\n",seed);
	} else {
		rd = fread(&seed,sizeof(seed),1,devrandom);
		if (rd != 1) printf("Error reading seed. ");
		if (verbose) printf("Got seed %u from /dev/random\n\n",seed);
		fclose(devrandom);
	}
	return(seed);
}
#endif
