
/*********************************************************************************
 *  Copyright© 2010 Gabriele Valentini (gabriele.valentini@mail.polimi.it)	 *
 *										 *
 *  This file is part of Evoptool.						 *
 * 										 *
 *  Evptool is free software: you can redistribute it and/or modify              *
 *  it under the terms of the GNU General Public License as published by         *
 *  the Free Software Foundation, either version 3 of the License, or            *
 *  (at your option) any later version.                                          *
 *										 *
 *  Evoptool is distributed in the hope that it will be useful,                  *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of  		 *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 		 *
 *  GNU General Public License for more details.				 *
 *										 *
 *  You should have received a copy of the GNU General Public License		 *
 *  along with Evoptool.  If not, see <http://www.gnu.org/licenses/>.    	 *	
 *********************************************************************************/

#include "BivariateDEUM.h"

/* Class costructor. */
BivariateDEUM::BivariateDEUM(unsigned int pop_size, double cooling_rate, int sampler_iterations, unsigned int chain_offset, const gsl_rng* rnd) :
	DEUM(pop_size, cooling_rate, sampler_iterations, rnd),
	_chain_offset(chain_offset) {

}

/* Class destructure. */
BivariateDEUM::~BivariateDEUM() {

}

/* Sets the MRF structure for the algorithm and initialize the coefficients vector. */
void BivariateDEUM::setupStructure() {
	genBivariates(_chain_offset);
	_alpha = gsl_vector_alloc(_mrf.size() + 1);
}

/* Returns the algorithm name. */
string BivariateDEUM::getName() {
	return "BivariateDEUM";
}
