 
/*********************************************************************************
 *  Copyright© 2010 Luigi Malagò (malago@elet.polimi.it)                         *
 *										 *
 *  This file is part of Evoptool.						 *
 * 										 *
 *  Evptool is free software: you can redistribute it and/or modify              *
 *  it under the terms of the GNU General Public License as published by         *
 *  the Free Software Foundation, either version 3 of the License, or            *
 *  (at your option) any later version.                                          *
 *										 *
 *  Evoptool is distributed in the hope that it will be useful,                  *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of  		 *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 		 *
 *  GNU General Public License for more details.				 *
 *										 *
 *  You should have received a copy of the GNU General Public License		 *
 *  along with Evoptool.  If not, see <http://www.gnu.org/licenses/>. 		 *	
 *********************************************************************************/

#ifndef CGA_H_
#define CGA_H_

#include "UnivariateEDA.h"

using namespace std;

/* This class defines the implementation of compact genetic algorithm (cGA). Look that the _popSize parameter 
 * inherited from abstract object UnivariateEDA does not refer to the real population size, that for cGA is fixed
 * to 2 inidividuals, but refers to the size of update step of probability vector, as described in related cGA 
 * publications. */

class cGA : public UnivariateEDA {
	public:
		cGA(unsigned int popSize, const gsl_rng* rnd);
		virtual ~cGA();

		void estimation();
		void sampling();
		void selection();
		
		void run();
		string getName();
};
#endif
