
/*********************************************************************************
 *  Copyright© 2010 Gabriele Valentini (gabriele.valentini@mail.polimi.it)	 *
 *										 *
 *  This file is part of Evoptool.						 *
 * 										 *
 *  Evptool is free software: you can redistribute it and/or modify              *
 *  it under the terms of the GNU General Public License as published by         *
 *  the Free Software Foundation, either version 3 of the License, or            *
 *  (at your option) any later version.                                          *
 *										 *
 *  Evoptool is distributed in the hope that it will be useful,                  *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of  		 *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 		 *
 *  GNU General Public License for more details.				 *
 *										 *
 *  You should have received a copy of the GNU General Public License		 *
 *  along with Evoptool.  If not, see <http://www.gnu.org/licenses/>.    	 *	
 *********************************************************************************/

#include "sBOA.h"
#include "path.h"

using namespace std;

/* CLass constructor. */
sBOA::sBOA(string filename) : EDA(0, NULL) {
	filename_ = filename;	
	done_ = false;
}

/* Class destructor. */
sBOA::~sBOA() {

}

/* This function defines the wrapper around the original implementation of sBOA. */
void sBOA::run() {
	if (!done_) {
		char cmd[250];
		int rval;
		cerr << "[sBOA] Wrapping sBOA";
		sprintf(cmd,"cd %s ; %s %s", SBOA_BIN_PATH, SBOA_EXE, filename_.c_str());
		rval = system(cmd);
		cerr << "[sBOA] sBOA Done - returned value " << rval << endl;
		done_ = true;
	}
}

/* This function computes and store the statistical values into a Statistics object,
 * and returns it. */
Statistics* sBOA::computeStatistics() {
		Statistics *stat;
		BinaryInstance *instance;
		
		stat = new Statistics(0,0,0,0);
		instance = new BinaryInstance(objectiveFunctionSize_);
		instance->setAllBits(0);
		stat->setBestIndividual(instance);
		return stat;
}

/* Returns the algorithm name. */
string sBOA::getName() {
	return "sBOA";
}
