#set terminal pdf enhanced fsize 7
#set output 'test1.pdf'

#set terminal x11 enhanced
#set terminal svg size 1000 1000 fixed enhanced fname 'Times'  fsize 36
#set output "test1.svg"

#set term png enhanced size 1024,768
#IMAGE-SIZE#
set term png enhanced size 825,481
set output "../../evoptool-file/temp/image/avg.png"

#set boxwidth 1.5 absolute
#set border

set lmargin 4
set rmargin 1
set tmargin 3
set bmargin 3

#set style fill solid 1.00 border -1
#set style histogram clustered gap 1 title  offset character 0, 0, 0
#set datafile missing '-'

set ylabel "average fitness" #offset -1,0
set xlabel "generation" #offset 0,-0.5
#set zlabel "theta_{12}" #offset 0,-0.5

#set polar
#set grid polar
#set clip
set size 1

#set xtics axis nomirror
#set ytics axis nomirror
set zeroaxis
#set angles degrees

set samples 1000

#set style data histograms
set key right bottom
#set size ratio 1

#set xtics axis in scale 0.5,1.5 nomirror rotate by 0 offset character 0, 0, 0
#set ytics axis out scale 0.5,1.5 nomirror rotate by 0 offset character 0, 0, 0  
#set xtics 0,0.1,1
#set ytics 0,0.1,1
#set ztics 0,0.1,1
#set ytics nomirror

#set key outside


#set title "Convergency test"
#set xrange [0:21] noreverse nowriteback
#set yrange [0:1] noreverse nowriteback
#set zrange [0:1] noreverse nowriteback
#set ticslevel 0

#XRANGE#
set xrange [0:250] noreverse nowriteback

set yrange [0:100] noreverse nowriteback

#PLOT-DATA-SECTION#
plot "../../evoptool-file/temp/data/sBOA.dat" using 1:2 with lines lw 2 lt 1 title "sBOA"