 
 /*********************************************************************************
 *  Copyright© 2010 Gabriele Valentini (gabriele.valentini@mail.polimi.it),	 *
 *                  Luigi Malagò (malago@elet.polimi.it)                         *
 *										 *
 *  This file is part of Evoptool.						 *
 * 										 *
 *  Evptool is free software: you can redistribute it and/or modify              *
 *  it under the terms of the GNU General Public License as published by         *
 *  the Free Software Foundation, either version 3 of the License, or            *
 *  (at your option) any later version.                                          *
 *										 *
 *  Evoptool is distributed in the hope that it will be useful,                  *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of  		 *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 		 *
 *  GNU General Public License for more details.				 *
 *										 *
 *  You should have received a copy of the GNU General Public License		 *
 *  along with Evoptool.  If not, see <http://www.gnu.org/licenses/>. 		 *	
 *********************************************************************************/

#ifndef SGA_H_
#define SGA_H_ 1

#include "GA.h"

using namespace std;

/* This class defines the Simple Genetic algorithm with: 50% truncation selection, one-point crossover 
 * and bit-flip mutation */
class SGA : public GA {
public:
	SGA(int popSize, double mutRate, const gsl_rng* rnd);
	virtual ~SGA();
	
	void run();
	string getName();
	
	void selection(); /* Truncation Selection */
	void crossover(); /* One-point Crossover */
	void mutation();  /* Bit-Flip Mutation*/
};
#endif
