
/*********************************************************************************
 *  Copyright© 2010 Gabriele Valentini (gabriele.valentini@mail.polimi.it)	 *
 *										 *
 *  This file is part of Evoptool.						 *
 * 										 *
 *  Evptool is free software: you can redistribute it and/or modify              *
 *  it under the terms of the GNU General Public License as published by         *
 *  the Free Software Foundation, either version 3 of the License, or            *
 *  (at your option) any later version.                                          *
 *										 *
 *  Evoptool is distributed in the hope that it will be useful,                  *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of  		 *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 		 *
 *  GNU General Public License for more details.				 *
 *										 *
 *  You should have received a copy of the GNU General Public License		 *
 *  along with Evoptool.  If not, see <http://www.gnu.org/licenses/>.    	 *	
 *********************************************************************************/

#ifndef SGABINTOURN_H_
#define SGABINTOURN_H_ 1

#include "SGA.h"

using namespace std;

/* This class defines the Simple Genetic Algorithm with binary tournament selection. It maintains the 
 * single-point crossover and the bitflip muatation. */
class SGABinTourn : public SGA {
public:
	SGABinTourn(int popSize, double mutRate, const gsl_rng* rnd);
	virtual ~SGABinTourn();
	
	void run();
	string getName();
	void selection();
};
#endif
