
/*********************************************************************************
 *  Copyright© 2010 Gabriele Valentini (gabriele.valentini@mail.polimi.it)	 *
 *										 *
 *  This file is part of Evoptool.						 *
 * 										 *
 *  Evptool is free software: you can redistribute it and/or modify              *
 *  it under the terms of the GNU General Public License as published by         *
 *  the Free Software Foundation, either version 3 of the License, or            *
 *  (at your option) any later version.                                          *
 *										 *
 *  Evoptool is distributed in the hope that it will be useful,                  *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of  		 *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 		 *
 *  GNU General Public License for more details.				 *
 *										 *
 *  You should have received a copy of the GNU General Public License		 *
 *  along with Evoptool.  If not, see <http://www.gnu.org/licenses/>.    	 *	
 *********************************************************************************/

#ifndef SGAPOPWISECROSS_H_
#define SGAPOPWISECROSS_H_ 1

#include "SGA.h"

using namespace std;

/* This class defines the Simple Genetic Algorithm with uniform bitwise crossover instead of the 
 * single-point crossover. It maintains the truncation selection at 50% of the population and the
 * bitflip mutation. */
class SGAPopWiseCross : public SGA {
public:
	SGAPopWiseCross(int popSize, double mutRate, const gsl_rng* rnd);
	virtual ~SGAPopWiseCross();
	
	void run();	
	string getName();
	void crossover(); /* Population Wise Uniform Crossover*/

};
#endif
