
/*********************************************************************************
 *  Copyright© 2010 Gabriele Valentini (gabriele.valentini@mail.polimi.it)	 *
 *										 *
 *  This file is part of Evoptool.						 *
 * 										 *
 *  Evptool is free software: you can redistribute it and/or modify              *
 *  it under the terms of the GNU General Public License as published by         *
 *  the Free Software Foundation, either version 3 of the License, or            *
 *  (at your option) any later version.                                          *
 *										 *
 *  Evoptool is distributed in the hope that it will be useful,                  *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of  		 *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 		 *
 *  GNU General Public License for more details.				 *
 *										 *
 *  You should have received a copy of the GNU General Public License		 *
 *  along with Evoptool.  If not, see <http://www.gnu.org/licenses/>.    	 *	
 *********************************************************************************/

#include "SimpleGraphTab.h"        	

/* Class constructor. */
SimpleGraphTab::SimpleGraphTab(Glib::ustring &tabName) :
	StatisticsTab(tabName), 
	Gtk::Image() {

}

/* Class constructor. */
SimpleGraphTab::SimpleGraphTab(Glib::ustring &tabName, string &imageFile, string &gnuplotFile) :
	StatisticsTab(tabName),
	Gtk::Image(),
	_imageFile(imageFile),
	_gnuplotFile(gnuplotFile) {

}

/* Class destructor. */
SimpleGraphTab::~SimpleGraphTab() {
	
}

/* Refreshes the statistics visualization. In this case updating the graph image 
 * visualized. */
void SimpleGraphTab::refresh() {
	set(_imageFile);
}

/* Clears the page content, so the main notebook will be able to resize itself to its 
 * prefered size without contraints. */
void SimpleGraphTab::clearContent() {
	clear();
}

/* Sets the image file name and the gnuplot congifuration file name. */
void SimpleGraphTab::setFiles(string &imageFile, string &gnuplotFile) {
	_imageFile = imageFile;
	_gnuplotFile = gnuplotFile;
	set(_imageFile);
}

/* Returns the gnuplot configuration file name. */
const char* SimpleGraphTab::gnuplotFile() {
	return _gnuplotFile.c_str();
}
