
/*********************************************************************************
 *  Copyright© 2010 Gabriele Valentini (gabriele.valentini@mail.polimi.it)	 *
 *										 *
 *  This file is part of Evoptool.						 *
 * 										 *
 *  Evptool is free software: you can redistribute it and/or modify              *
 *  it under the terms of the GNU General Public License as published by         *
 *  the Free Software Foundation, either version 3 of the License, or            *
 *  (at your option) any later version.                                          *
 *										 *
 *  Evoptool is distributed in the hope that it will be useful,                  *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of  		 *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 		 *
 *  GNU General Public License for more details.				 *
 *										 *
 *  You should have received a copy of the GNU General Public License		 *
 *  along with Evoptool.  If not, see <http://www.gnu.org/licenses/>.    	 *	
 *********************************************************************************/

#ifndef SIMPLEGRAPHTAB_H
#define SIMPLEGRAPHTAB_H

#include "StatisticsTab.h"

using namespace std;

/* This class defines the widget for a simple graphic visualization. */

class SimpleGraphTab : public StatisticsTab, public Gtk::Image {
		string _imageFile;
		string _gnuplotFile;
	public:	
        	SimpleGraphTab(Glib::ustring &tabName);
        	SimpleGraphTab(Glib::ustring &tabName, string &imageFile, string &gnuplotFile);
        	virtual ~SimpleGraphTab();

        	void refresh();
        	void clearContent();
        	void setFiles(string &imageFile, string &gnuplotFile);
        	const char* gnuplotFile();
};
#endif
