
/*********************************************************************************
 *  Copyright© 2010 Gabriele Valentini (gabriele.valentini@mail.polimi.it)	 *
 *										 *
 *  This file is part of Evoptool.						 *
 * 										 *
 *  Evptool is free software: you can redistribute it and/or modify              *
 *  it under the terms of the GNU General Public License as published by         *
 *  the Free Software Foundation, either version 3 of the License, or            *
 *  (at your option) any later version.                                          *
 *										 *
 *  Evoptool is distributed in the hope that it will be useful,                  *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of  		 *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 		 *
 *  GNU General Public License for more details.				 *
 *										 *
 *  You should have received a copy of the GNU General Public License		 *
 *  along with Evoptool.  If not, see <http://www.gnu.org/licenses/>.    	 *	
 *********************************************************************************/

#ifndef STATISTICSTAB_H
#define STATISTICSTAB_H

#include <libglademm.h>
#include <gtkmm.h>

using namespace std;

/* This abstract class defines the superclass for the StatisticsTab hierarchy. */

class StatisticsTab {
		const Glib::ustring _tabName;
	public:
        	StatisticsTab(Glib::ustring &tabName);
        	virtual ~StatisticsTab();
        	
        	virtual void refresh() = 0;		/* Refresh the visualization of statistics.			*/
        	virtual void clearContent() = 0; 	/* Clear the content of widget in order to rezite notebook.	*/
        	
        	const Glib::ustring& tabName();
};
#endif
