
/*********************************************************************************
 *  Copyright© 2010 Gabriele Valentini (gabriele.valentini@mail.polimi.it)	 *
 *										 *
 *  This file is part of Evoptool.						 *
 * 										 *
 *  Evptool is free software: you can redistribute it and/or modify              *
 *  it under the terms of the GNU General Public License as published by         *
 *  the Free Software Foundation, either version 3 of the License, or            *
 *  (at your option) any later version.                                          *
 *										 *
 *  Evoptool is distributed in the hope that it will be useful,                  *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of  		 *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 		 *
 *  GNU General Public License for more details.				 *
 *										 *
 *  You should have received a copy of the GNU General Public License		 *
 *  along with Evoptool.  If not, see <http://www.gnu.org/licenses/>.    	 *	
 *********************************************************************************/

#ifndef XML_PARSER_H
#define XML_PARSER_H

#include <libxml++/libxml++.h>
#include <libxml++/parsers/textreader.h>

#include "Evoptool.h"

using namespace std;

/* This class implement the parser for the test configuration file, need to run 
   evoptool in command line mode. */

class XMLParser {
	
	struct AlgorithmParameters {
		int algoID;
		int parametersCount;
		char *parametersType;        
        };
      
	public:        	
        	static bool parse(Evoptool::TestParameters *params, const char *file);
       
        private: 
        	static int toInt(Glib::ustring value);
        	static char* toChars(Glib::ustring value);
        	static bool toBool(Glib::ustring value);
        	static double toDouble(Glib::ustring value);

        	static bool parseConfiguration(xmlpp::TextReader &reader, Evoptool::TestParameters *params);
        	static bool parseTask(xmlpp::TextReader &reader, Evoptool::TestParameters *params);
        	static bool parseResolutors(xmlpp::TextReader &reader, Evoptool::TestParameters *params);
        	static Glib::ustring readNodeContent(xmlpp::TextReader &reader, const Glib::ustring &nodeName, bool *errorFlag);
};
#endif
