 
/*********************************************************************************
 *  Copyright© 2010 Luigi Malagò (malago@elet.polimi.it)                         *
 *										 *
 *  This file is part of Evoptool.						 *
 * 										 *
 *  Evptool is free software: you can redistribute it and/or modify              *
 *  it under the terms of the GNU General Public License as published by         *
 *  the Free Software Foundation, either version 3 of the License, or            *
 *  (at your option) any later version.                                          *
 *										 *
 *  Evoptool is distributed in the hope that it will be useful,                  *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of  		 *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 		 *
 *  GNU General Public License for more details.				 *
 *										 *
 *  You should have received a copy of the GNU General Public License		 *
 *  along with Evoptool.  If not, see <http://www.gnu.org/licenses/>. 		 *	
 *********************************************************************************/

#include <math.h>
#include "BinVal.h"

/* Class constructor. */
BinVal::BinVal(int size) : ObjectiveFunction(size) {

}

/* Class destructor. */
BinVal::~BinVal() {

}

/* Fitness function. */
double BinVal::f(BinaryInstance *bi) {
	if (bi!=NULL) {
		if(!(bi->validCache())) { 
			/* Fitness cache value not valid */
			double sum = 0;
			for (int j=0; j<_size; j++) {
				sum += (pow(2,j))*bi->get(j);
			}
			volatile double retValue = sum/(pow(2,_size)-1)*100.0;
			bi->setFitnessCache(retValue);
			return retValue;
		} else {
			return bi->getFitnessCache();
		}
	} else {
		cerr << "[BinVal::f] binary instance cannot be null" << endl;
		return -1;
	}
}

